;TIP1225A.LSP:      LISPEDIT.LSP      (C)1996, Frances E. Gainer 

;Requires LISPEDIT.DCL.
;This utility aids the programmer in quickly selecting,
;previewing, editing, and loading AutoLisp files.

(defun c:ls (/ dia_mode var fntxt fn)
   (if (< (setq pop
       (load_dialog "lispedit.dcl")) 0) (exit))
   (setq dia_mode 4)
   (while (< 2 dia_mode)                        ;;sets up a loop
   (if (not                                     ;;for hiding dialog
       (new_dialog "lispedit" pop))(exit))   
   (if le:fn (set_tile "lefn" le:fn))
   (action_tile "lefn" "(le_fn)")                   ;;file tile
   (action_tile "lefnsl" "(le:sel)")                ;;select file
   (action_tile "leprn" "(if (and le:fn             ;;print button
      (findfile le:fn)) (done_dialog 3) (le:err))")
   (action_tile "prev" "(if (and le:fn
      (findfile le:fn)) (tlsp)(le:err))")           ;;view file
   (action_tile "leed" "(if le:fn
      (done_dialog 4)(le:err))") ;;edit file
   (action_tile "load" "(if (and le:fn (findfile le:fn))
      (progn (setq var 1) (done_dialog)) (le:err))") ;;load file
   (action_tile "exit" "(setq var nil)(done_dialog)");;exit
   (setq dia_mode (start_dialog))
      (cond ((= dia_mode 4) (initget 1)              ;;conditions
         (command "edit" le:fn) (princ))             ;;for hiding
      )                                              ;;dialog
      (cond ((= dia_mode 3)
         (command ".shell" (strcat "print " le:fn)) (princ))
      )
   )
   (unload_dialog pop)
   (if var (load le:fn))
   (princ)
)
(defun le:err ()
   (set_tile "error" "Please select a valid file")     ;;HEY!
)
(defun le_fn ()
   (setq le:fn (get_tile "lefn"))                      ;;set le:fn
   (setq le:fn (strcase $value le:fn))
   (set_tile "error" "")
)
(defun le:sel ()
   (setq le:fn (getfiled "Select File to Edit" "/acad/support/" "lsp" 0))
   (if le:fn (set_tile "lefn" le:fn))                ;;get le:fn
   (set_tile "error" "")                             ;;from box
)
;;Tlsp provides the ability to preview AutoLisp files prior to editing.
(defun tlsp ()
   (if le:fn (setq fn (open le:fn "r")))             ;;open le:fn
   (if (not (new_dialog "tlsp" pop)) (exit))         ;;to read
      (progn
         (set_tile "bar" le:fn)                      ;;display le:fn
         (start_list "pvbox")                        ;;in list box
         (while
            (setq fntxt (read-line fn))
            (add_list fntxt)
         )
         (end_list)
         (setq fn (close fn))
         (start_dialog)
      )
  (princ)
)
(princ "  LISPEDIT loaded.  Start command with LS. ") (princ)
