;Tip1226.LSP:      ALLBEAMS.LSP      Draw Steel Beams     (C)1996, Brian Farrel

(prompt "\nTo execute this program type ALLBEAMS.\n")
(defun dtr (A)
   (* pi (/ a 180.0)))
(defun c:allbeams (/ FLANGE DEPTH FLTHK WTHK ANG P1 CHOICE LENGTH
               DEPTH2 FLANGE2 RAD P1 P2 P3 P4 P5 P6 P7 P8 P9
               P10 P11 P12 )
   (setvar "CMDECHO" 0)
   (setq
      FLANGE (getreal "\nGive me your Flange width: ")
      DEPTH (getreal "\nGive your Beam depth: ")
      FLTHK (getreal "\nGive your Flange thickness: ") 
      WTHK (getreal "\nGive your Web thickness: ")
      LENGTH (getreal "\nGive your overall exact Length: ")
      ANG (getangle "\nGive your Rotation angle: ") 
      
   ) ; the end of user input
 (if (= ANG nil)
     (setq ANG 0)
   )
 (setq DEPTH2 (- DEPTH (* FLTHK 2))
       FLANGE2 (- (/ FLANGE 2) (/ WTHK 2))
       RAD (/ FLTHK 2) )
 (prompt "\nOK, What do you want? Cross Section, Plan or Elevation")
 (MENU)
)
 (defun MENU ()
    (initget "Cross Plan Elevation Quit")
    (setq CHOICE (getpoint "\nCross/Plan/Elevation/Quit: "))
    (cond
       ((= CHOICE "Cross")
       (CROSS)
       )
       ((= CHOICE "Plan")
       (PLAN)
       )
       ((= CHOICE "Elevation")
       (ELE)
       )  
       ((= CHOICE "Quit")
       (OK)
       )
       ((null CHOICE)
       (prompt"\nYou must enter C,P,E, or Q!")
       (MENU)
       )
    )
 )
 
 (defun CROSS ()
 ; CROSS SECTION
  (setq P1 (getpoint "\nGive your Origin point: "))  
  (setq P2 (polar P1 ANG FLANGE)
      P3 (polar P2 (+ (dtr 90) ANG) FLTHK)
      P4 (polar P3 (+ (dtr 180) ANG) FLANGE2)
      P5 (polar P4 (+ (dtr 90) ANG) DEPTH2)
      P6 (polar P5 ANG FLANGE2)
      P7 (polar P6 (+ (dtr 90) ANG) FLTHK)
      P8 (polar P7 (+ (dtr 180) ANG) FLANGE)
      P9 (polar P8 (+ (dtr 270) ANG) FLTHK)
      P10 (polar P9 ANG FLANGE2)
      P11 (polar P10 (+ (dtr 270) ANG) DEPTH2)
      P12 (polar P11 (+ (dtr 180) ANG) FLANGE2)
  ) ;  
 (command "pline" P12 "w" 0 0 P1 P2 P3 "")
 (command "pline" P6 "w" 0 0 P7 P8 P9 "")
 (command "pline" P6 "w" 0 0 P5 P4 P3 "")
 (command "fillet" "r" RAD "fillet" "polyline" "l")
 (command "pline" P12 "w" 0 0 P11 P10 P9 "")
 (command "fillet" "r" RAD "fillet" "polyline" "l") 
 (command "pedit" "w" P1 P7 "j" "w" P1 P7 "" "")
 (redraw)
 (MENU)
 )


 (defun PLAN ()
  ;PLAN
  (setq P1 (getpoint "\nGive your Origin point: "))
  (setq P13 P1
      P14 (polar P13 ANG FLANGE2)
      P15 (polar P14 ANG WTHK)
      P16 (polar P15 ANG FLANGE2)
      P17 (polar P16 (+ (dtr 90) ANG) LENGTH)
      P18 (polar P17 (+ (dtr 180) ANG) FLANGE2)    
      P19 (polar P18 (+ (dtr 180) ANG) WTHK)
      P20 (polar P19 (+ (dtr 180) ANG) FLANGE2)

     ) 
 
     (command "pline" P13 "w" 0 0 P16 P17 P20 P13 "")
     (command "linetype" "s" "dashed" "")
     (command "line" P14 P19 P18 P15  "")
     (command "linetype" "s" "continuous" "")
     (redraw)
     (MENU)
 )


 (defun ELE ()
  ;ELEVATION
  (setq P1 (getpoint "\nGive your Origin point: "))
  (setq P21 P1
      P22 (polar P21 ANG LENGTH)
      P23 (polar P22 (+ (dtr 90) ANG) FLTHK)
      P24 (polar P23 (+ (dtr 180) ANG) LENGTH)
      P25 (polar P24 (+ (dtr 90) ANG) DEPTH2)
      P26 (polar P25 ANG LENGTH)    
      P27 (polar P26 (+ (dtr 90) ANG) FLTHK)
      P28 (polar P27 (+ (dtr 180) ANG) LENGTH)

  ) 

  (command "linetype" "s" "continuous" "") 
  (command "pline" P21 "w" 0 0 P22 P23 P24 P25 P26 P27 P28 P21 P22 P27 "") 
  (redraw)
  (MENU)
 )


 
(defun OK ()
(setvar "CMDECHO" 1)
(prompt "\nFair enough, be that way.\n")
)

