;Tip1228.LSP:      CHLAYER.LSP      Change Layers      (C)1996, Steve Johnston

;;;This program provides a dialog box for setting the current layer.  This is
;;;faster than using DDLMODES to set the current layer because: 
;;;   1) You only have to double click the layer name in CHLAYER, as opposed 
;;;      to clicking the layer name , selecting "Current", then "OK" in 
;;;      DDLMODES.
;;;   2) You can display more layer names at a time in CHLAYER than in
;;;      DDLMODES, therefore you don't have to scroll through the list as
;;;      much to reach the layer names at the bottom of the list.  (You can 
;;;      change the height of the list box in CHLAYER.DCL to optimize the
;;;      length for your screen.


(defun *cng_err* (msg)
   (if (/= msg "Function cancelled")
      (if (= msg "quit / exit abort")   
         (princ)
         (princ (strcat "\nError: " msg))
      )
   )
   (setq *error* *err_old* *err_old* nil)
   (princ)
)

(defun c:chlayer ( / dcl_id lnlist lboxlist llist lname set_lay)
   (setq *err_old* *error* *error* *cng_err*)
   (setq dcl_id (load_dialog "chlayer.dcl"))
   (cond ((not (new_dialog "chlayer" dcl_id))
          (princ "Unable to load ChLAYER.DCL.")
          (exit))
   )

;;;Create list of layers--This is a streamlined version of the list maker for
;;;                       DDLMODES.
   (setq lnlist nil lboxlist nil)
   (setq llist (tblnext "layer" T))
   (while llist
      (setq lname (cdr (assoc 2 llist)))
      (setq lnlist (append lnlist (list lname)))
      (setq llist (tblnext "layer"))
   )
   (if lnlist (setq lnlist (acad_strlsort lnlist)))
   
;;;Handle the dialog box   
   (action_tile "layerbox" "(setq set_lay (nth (atoi $value) lnlist))")
   (action_tile "cancel" "(exit)")
   
   (start_list "layerbox")
   (mapcar 'add_list lnlist)
   (end_list)

   (start_dialog)
   (unload_dialog dcl_id)

;;;Set the current layer
   (setvar "clayer" set_lay)
   
   (setq *error* *err_old* *err_old* nil)
   (princ)
); end chlayer.lsp
